api/urls.py
from django.urls import path, include
from rest_framework import routers
from api import views

# Routers - provee una manera facil de redirigir a los endpoint
# metodos accecibles GET, POST, PUT, DELETE
router = routers.DefaultRouter()

# rutas de app clientes
router.register(r'localidades', views.LocalidadsViewSet)
router.register(r'clientes', views.ClienteViewSet)
router.register(r'instalaciones', views.InstalacionViewSet)
router.register(r'contadores', views.ContadorViewSet)
router.register(r'pagos', views.PagoViewSet)

# rutas de app equipos
router.register(r'modems', views.ModemViewSet)
router.register(r'emisoras', views.EmisoraViewSet)
router.register(r'antenas', views.AntenaViewSet)

# Wire up our API using automatic URL routing.
# Additionally, we include login URLs for the browsable API.
urlpatterns = [
    path('', include(router.urls)),
    # path('api-auth/', include('rest_framework.urls', namespace='rest_framework'))
]

app_perfiles/urls.py
from django.urls import path
from django.contrib.auth import views as auth_views
from app_perfiles.views import *

app_name = 'perfiles'

urlpatterns = [
    # CRUD de usuarios
    path('usuarios/users-list/', UserList.as_view(), name="users_list"),
    path('usuarios/users-add/', user_admin, name="user_add"),
    path('usuarios/users-modify/<int:pk>', user_admin, name="user_modify"),
    path('usuarios/users-del/<int:pk>', UserDelete.as_view(), name="user_del"),
    
    # CRUD de grupos
    path('users/groups/list', UserGroupList.as_view(), name="users_groups_list"),
    path('users/groups/add', user_groups_admin, name="users_groups_new"),
    path('users/groups/modify/<int:pk>', user_groups_admin, name="users_groups_modify"),
    path('users/groups/delete/<int:pk>', user_group_delete, name="user_group_delete"),
]

zanet/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from rest_framework.documentation import include_docs_urls
from django.conf.urls.static import static

urlpatterns = [
    path('', include(('bases.urls', 'bases'), namespace="bases")),
    path('', include(('app_clientes.urls', 'app_clientes'), namespace="app_clientes")),
    path('', include(('app_equipos.urls', 'app_equipos'), namespace="app_equipos")),
    path('', include(('app_perfiles.urls', 'app_perfiles'), namespace="app_perfiles")),
    path('', include(('app_publicidad.urls', 'app_publicidad'), namespace="app_publicidad")),
    path('admin/', admin.site.urls),
    path('api/v1/', include('api.urls')),
    path('docs/', include_docs_urls(title='API Documentación')),
]

urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)
urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

app_perfiles/models.py
from django.db import models
from django.utils import timezone
# from django.utils.http import urlquote
from urllib.parse import quote
# from django.utils.translation import ugettext_lazy as _
from django.utils.translation import gettext_lazy as _
from django.contrib.auth.models import AbstractBaseUser, PermissionsMixin

from .managers import UsuarioManager

# Create your models here.
class Usuario(AbstractBaseUser, PermissionsMixin):
    """ modelo de usuario personalizado"""
    email = models.EmailField(_('direccion email'), max_length=254, unique=True)
    first_name = models.CharField(_('nombres'), max_length=30, blank=True)
    last_name = models.CharField(_('apellidos'), max_length=30, blank=True)
    is_staff = models.BooleanField(_('es_staff'), default=False, help_text='Indica si el usuario puede iniciar sesion en admin')
    is_active = models.BooleanField(_('activo'), default=True, help_text='Designa si este usuario es trartado como activo' 'Deseleccione esto en lugar de eliminar cuentas')
    date_joined =models.DateTimeField(_('fecha de registro'), default=timezone.now)
    
    # el username lo remplazamos con email
    USERNAME_FIELD = 'email' 
    REQUIRED_FIELDS = []
    
    objects = UsuarioManager()
    
    class Meta:
        verbose_name = _('usuario')
        verbose_name_plural = _('usuarios')
        
    def get_absolute_url(self):       
        return reverse('/users/%s' % quote(self.email))
    
    def get_full_name(self):
        full_name = "%s %s" %(self.first_name, self.last_name)
        return full_name.strip()
        
    def get_short_name(self):
        return self.first_name

app_perfiles/forms.py
from django.contrib.auth.forms import UserCreationForm, UserChangeForm
from .models import Usuario
from django.forms import fields
from django.db import models
from django import forms
from django.forms.widgets import PasswordInput

class UsuarioCreationForm(UserCreationForm):
    """ form para crear un usuario solo con email y password"""
    
    def __init__(self, *args, **kwargs):
        super(UsuarioCreationForm, self).__init__(*args, **kwargs)
        
    class Meta:
        model = Usuario
        fields = ('email',)
    
class UsuarioChangeForm(UserChangeForm):
    """ form para editar un usuario"""
    
    def __init__(self, *args, **kwargs):
        super(UsuarioChangeForm, self).__init__(*args, **kwargs)
        
    class Meta:
        model = Usuario
        fields = '__all__'
        
class UserForm(forms.ModelForm):
    """ form para crear usuario"""
    password = forms.CharField(widget=PasswordInput)
    
    class Meta:
        model = Usuario
        fields = ['email', 'first_name', 'last_name', 'password']
        widget = {'email': forms.EmailInput, 'password': forms.PasswordInput}
    
    # a todos los elementos del form le ponemos la clase form-control
    def __init__(self, *args, **kwargs):
        """ método que itera los campos del form y agrega la clase form-control de bootstrap a los input"""
        super().__init__(*args, **kwargs)
        for field in iter(self.fields):
            self.fields[field].widget.attrs.update({
                'class': 'form-control'
            })
    

app_perfiles/views.py
from django.shortcuts import render, redirect
from django.views.generic import *
from django.contrib.auth.mixins import LoginRequiredMixin, PermissionRequiredMixin
from django.contrib.auth.decorators import login_required, permission_required
from django.contrib.auth.models import Group, Permission
from bases.views import Sin_Privilegios
from django.contrib.auth.hashers import make_password
from django.urls import reverse_lazy
from django.db.models import Q
from django.http import HttpResponse

from .models import Usuario
from .forms import UserForm

# Create your views here.
class UserList(Sin_Privilegios, ListView):
    """ vbc para listar usuarios"""
    permission_required = "app_perfiles:view_usuario"
    model = Usuario
    template_name = "app_perfiles/users_list.html"
    login_url = "bases:login"
    context_object_name = "obj"
    
@login_required(login_url='/login/') # debe estar logeado 
@permission_required('app_perfiles.add_usuario', login_url='bases:sin_privilegios') 
@permission_required('app_perfiles.change_usuario', login_url='bases:sin_privilegios') 
def user_admin(request, pk=None):
    """ vista basada en función para crear/editar un usuario"""        
    template_name = "app_perfiles/users_add.html"
    context = {}    
    form = None
    obj = None
    
    if request.method == "GET":
        if not pk:
            form = UserForm(instance = None) # form vacío
        else:
            obj = Usuario.objects.filter(id=pk).first()
            form = UserForm(instance = obj)
        
        context["form"] = form
        context["obj"] = obj
    
    # capturamos los datos que vienen del form para enviarlos y/o guardarlos en DB
    if request.method == "POST":
        data = request.POST
        # capturamos los datos que vienen del form
        e = data.get("email")
        fn = data.get("first_name")
        ln = data.get("last_name")
        p = data.get("password")
        
        # validamos si el email ya existe        
        if pk:
            obj = Usuario.objects.filter(id=pk).first()
            if not obj:
                print("Error, usuario no existe")
            else:
                # creamos el usuario con los datos del form
                obj.email = e
                obj.first_name = fn
                obj.last_name = ln 
                obj.password = make_password(p) # enchiptamos el password con el hash
                obj.save()  
        
        else:
            obj = Usuario.objects.create_user(
                email = e, 
                password = p,
                first_name = fn,
                last_name = ln                
            )  
            
            print(obj.email, obj.password)
        
        return redirect('app_perfiles:users_list')
        
    return render(request, template_name, context)

class UserDelete(Sin_Privilegios, DeleteView):
    """ vista basada en clase para eliminar un usuario"""
    permission_required = "app_perfiles.delete_usuario"
    model = Usuario
    template_name = "app_perfiles/users_del.html"
    context_object_name = "obj"
    #success_message = "Localidad eliminada satisfactoriamente.."
    success_url = reverse_lazy("app_perfiles:users_list")
    
class UserGroupList(Sin_Privilegios, ListView):
    """ vbc para listar grupos de usuarios"""
    permission_required = "app_perfiles:view_usuario"
    model = Group
    template_name = "app_perfiles/user_group_list.html"
    login_url = "app_perfiles:login"
    context_object_name = "obj"
    
@login_required(login_url='/login/')
@permission_required('app_perfiles:change_usuario', login_url='bases:sin_privilegios')
def user_groups_admin(request, pk=None):
    """ permisos para un grupo"""
    template_name = "app_perfiles/users_group_add.html"
    context = {}
    
    # si existe el grupo
    obj = Group.objects.filter(id = pk).first()
    context['obj'] = obj
    permisos = {}
    permisos_grupo = {}
    context['permisos'] = permisos
    context['permisos_grupo'] = permisos_grupo
    
    if obj:
        # obtenemos los permisos de grupo
        permisos_grupo = obj.permissions.all()
        context['permisos_grupo'] = permisos_grupo
        
        # consultamos todos los permisos, exceptuando los que ya tiene el grupo
        permisos = Permission.objects.filter(~Q(group=obj))
        context["permisos"] = permisos
        
    # print(permisos)
    # print(permisos_grupo)
    
    if request.method == "POST":
        name = request.POST.get("name")
        grp = Group.objects.filter(name=name).first()
        
        if grp and grp.id != pk:
            print("Grupo ya existe, no puede volver a crearlo")
            return redirect("perfiles:users_groups_new")
        
        if not grp and pk != None:
            # Grupo existe, se está cambiando el nombre
            grp = Group.objects.filter(id=pk).first()
            grp.name = name
            
        elif not grp and pk == None: 
            grp = Group(name=name)
        else:
            ...
            
        grp.save()
        return redirect("perfiles:users_groups_modify", grp.id)
                
    return render(request, template_name, context)

@login_required(login_url='/login/')
@permission_required('app_perfiles:change_usuario', login_url='bases:sin_privilegios')
def user_group_delete(request, pk):
    """ vbf para borra grupo"""
    if request.method == "POST":
        grp = Group.objects.filter(id=pk).first()
        
        if not grp:
            print("Grupo no existe")
        else:
            grp.delete()
        
        return HttpResponse("OK")
    

app_perfiles/templates/app_perfiles/user_group_list.html
{% extends 'bases/home.html' %}

{% load static %}

{% block content %}
    <section class="content">
        <div class="content-fluid">
            <div class="row">
                <div class="col-12">
                    <div class="card">
                        <div class="card-header">
                          <h3 class="card-title text-uppercase">Listado de grupos</h3>
                          <div class="d-flex justify-content-end">
                            <a href="{% url 'perfiles:users_groups_new' %}">
                            <button class="btn btn-secondary" style="font-size: 14px; font-family: 'Segoe UI', Tahoma, Geneva, Verdana, sans-serif; font-weight: 600;">
                              <i class="fas fa-plus-circle"></i><span> Agregar grupo</span>
                            </button></a>
                          </div>
                        </div>
                        <!-- /.card-header -->
                        <div class="card-body">

                          {% if not obj %}
                            <div class="alert alert-info">No hay grupos registrados</div>           
                          {% else %}

                            <table id="example1" class="table table-bordered table-striped">
                              <thead>
                              <tr class="table-info" style="font-size: small;">
                                <th>ID</th>                                
                                <th>NOMBRE</th>                                                             
                                <th>ACCIONES</th>
                              </tr>
                              </thead>
                              <tbody>
                                {% for item in obj %}                                  
                                  <tr class="text-secondary" style="font-size: small; font-family: Nunito, system-ui, -apple-system, BlinkMacSystemFont">                                                                    
                                      <td>{{ item.id }}</td>                                      
                                      <td>{{ item.name }}</td>
                                                                                                                                            
                                      <td>                                                                                                                         
                                        <a href="{% url 'app_perfiles:users_groups_modify' item.id %}">
                                          <button class="btn btn-primary bg-warning btn-outline-light btn-sm" >
                                            <i class="fa fa-edit"></i> <span style="color: white;"> Editar</span>
                                          </button>
                                        </a>
                                                                                                                                                                 
                                        <button type="button" class="btn btn-primary bg-danger btn-outline-light btn-sm"
                                          onclick='return abrir_borrar("{{ item.name }}", "{% url 'perfiles:user_group_delete' item.id %}")'>
                                          <i class="fa fa-trash-alt"></i> <span style="color: white;"> Borrar</span>
                                        </button>
                                                                                
                                      </td>                                                                      
                                  </tr>
                                  {% endfor %}                              
                              
                              </tbody>                            
                            </table>
                            <!-- /.table -->
                            {% endif %}
                        </div>
                        <!-- /.card-body -->
                      </div>
                      <!-- /.card -->
                    </div>
                    <!-- /.col -->
                </div>
            </div>
        </div>
    </section>
{% endblock content %}

  

    
    

app_perfiles/templates/app_perfiles/users_del.html
{% extends 'bases/home.html' %}

{% load static %}

{% block content %}
<!-- Content Header (Page header) -->
<div class="content-header">
  <section class="content">
    <div class="container-fluid">
      <div class="row">
        <div class="col-4">
          <form method="post">
            {% csrf_token %}
            <!-- Input addon -->
            <!-- card -->
            <div class="card card-danger">                            
              <div class="card-header">
                <h3 class="card-title text-uppercase">Usuarios</h3>

                <div class="col-auto d-flex justify-content-end">
                  <i class="far fa-question-circle fa-2x text-gray-300"></i>                           
                </div>
              </div>

              <!-- card-body -->
              <div class="card-body">
                <div class="col-12">
                  <div class="font-weight-light mb-1" style="font-family: Arial, Helvetica, sans-serif; font-size: large;"> ¿Deseas eliminar al usuario: 
                    <span class="text-primary" style="text-decoration-line: line-through;"> {{ obj.email }}</span> ?
                  </div>

                  <img class="card-img-top p-4" src="{% static 'dist/img/remove-user.png' %}" height="280px" alt="modem">
                    
                    <div class="row mt-2">
                      <div class="col-6">
                        <button type="submit" class="btn btn-danger btn-block"><i class="fas fa-check-circle"></i> Si, Eliminar</button>
                      </div>

                      <div class="col-6">
                        <a href="{% url 'perfiles:users_list' %}" class="btn btn-success btn-block"><span class="fas fa-window-close"></span> Cancelar</a>
                      </div>
                    </div>                                        
                    
                </div> 
                                
              </div>
              <!-- /.card-body -->
            </div>
            <!-- /.card-header -->
          </div>        
        <!-- /.card -->
        </form>
        <!-- ./form -->
      </div>
    </div>
</div>
</section>
<!-- /.container-fluid -->
</div>
<!-- /.content-header -->
{% endblock content %}

app_perfiles/templates/app_perfiles/users_group_add.html
{% extends 'bases/home.html' %}

{% load static %}

{% block content_wraper %}

{% endblock content_wraper %}

{% block content %}
<div class="row">
    <div class="col-12">
        <div class="card">
            <div class="card-header">                
                {% if obj %} Editar {% else %} Crear {% endif %} Grupo de usuario                                    
            </div>

            <div class="card-body">
                <!-- form -->
                <form action="POST" class="form-group">
                    {% csrf_token %}

                    <div class="form-group">
                        <label for="IdNombre">Nombre</label>
                        <input type="text" class="form-control" id="id_name" name="name" placeholder="Nombre del grupo:"
                        value="{{ obj.name }}">
                    </div>

                    <div class="dropdown-divider"></div>
                    <button type="submit" class="btn bg-success btn-app" disabled>
                        <i class="fas fa-save"></i>Guardar
                    </button>

                    <button type="reset" class="btn bg-info btn-app">
                        <i class="fa fa-window-close"></i>Cancelar
                    </button>

                    <a href="{% url 'perfiles:users_groups_list' %}" class="btn btn-app bg-warning">
                        <i class="far fa-hand-point-left"></i>Regresar
                    </a>
                </form>
                <!-- ./form -->
            </div>
        </div>
    </div>
</div>

{% if obj %}
<div class="row">
    <!-- columna 1 -->
    <div class="col-6">
        .<div class="card">
            <div class="card-header">
                Permisos del grupo {{ obj }}
            </div>
            <div class="card-body">
                <table id="tblGrp" class="table table-bordered table-striped">
                    <thead>
                        <tr>
                            <th>ID</th>
                            <th>NOMBRE</th>
                            <th>ACCIONES</th>
                        </tr>
                    </thead>

                    <tbody>
                        
                        {% for item in permisos_grupo %}
                            <tr>
                                <td>{{ item.id }}</td>
                                <td>{{ item.name }}</td>
                                <td>
                                    <a href="#" class="btn btn-sm text-success">
                                        <i class="fa fa-trash"></i>
                                    </a>
                                </td>
                            </tr>
                        {% endfor %}
                            
                    </tbody>
                </table>
            </div>
        </div>
    </div>
    <!-- ./columna 1 -->

    <!-- columna 2 -->
    <div class="col-6">
        .<div class="card">
            <div class="card-header">
                Todos los permisos
            </div>
            <div class="card-body">
                <table id="example1" class="table table-bordered table-striped">
                    <thead>
                        <tr>
                            <th>ID</th>
                            <th>NOMBRE</th>
                            <th>ACCIONES</th>
                        </tr>
                    </thead>

                    <tbody>
                        
                        {% for item in permisos %}
                            <tr>
                                <td>{{ item.id }}</td>
                                <td>{{ item.name }}</td>
                                <td>
                                    <a href="#" class="btn btn-sm text-success">
                                        <i class="fa fa-plus"></i>
                                    </a>
                                </td>
                            </tr>
                        {% endfor %}
                            
                    </tbody>
                </table>
            </div>
        </div>
    </div>
    <!-- ./columna 2 -->
</div>
{% endif %}
    

{% endblock content %}

app_perfiles/templates/app_perfiles/users_list.html
{% extends 'bases/home.html' %}

{% load static %}

{% block content %}
    <section class="content">
        <div class="content-fluid">
            <div class="row">
                <div class="col-12">
                    <div class="card">
                        <div class="card-header">
                          <h3 class="card-title text-uppercase">Listado de usuarios</h3>
                          <div class="d-flex justify-content-end">
                            <a href="{% url 'app_perfiles:user_add' %}">
                            <button class="btn btn-secondary" style="font-size: 14px; font-family: 'Segoe UI', Tahoma, Geneva, Verdana, sans-serif; font-weight: 600;">
                              <i class="fa fa-user-plus"></i><span> Agregar usuario</span>
                            </button></a>
                          </div>
                        </div>
                        <!-- /.card-header -->
                        <div class="card-body">

                          {% if not obj %}
                            <div class="alert alert-info">No hay usuarios registrados</div>           
                          {% else %}

                            <table id="example1" class="table table-bordered table-striped">
                              <thead>
                              <tr class="table-info" style="font-size: small;">
                                <th>ID</th>
                                <th>CORREO ELECTRÓNICO</th>
                                <th>NOMBRE</th>  
                                <th>IS STAFF</th>                              
                                <th>IS SUPERUSER</th>                                
                                <th>ACCIONES</th>
                              </tr>
                              </thead>
                              <tbody>
                                {% for item in obj %}                                  
                                  <tr class="text-secondary" style="font-size: small; font-family: Nunito, system-ui, -apple-system, BlinkMacSystemFont">                                                                    
                                      <td>{{ item.id }}</td>
                                      <td>{{ item.email }}</td>
                                      <td class="text-uppercase">{{ item.get_full_name }}</td>
                                      
                                      {% if item.is_staff %}
                                        <td>{{ item.is_staff|yesno:"Si,No" }}</td>
                                      {% else %}
                                        <td>{{ item.is_staff|yesno:"Si,No" }}</td>
                                      {% endif %}
                                        
                                      {% if item.is_superuser %}                                        
                                        <td>{{ item.is_staff|yesno:"Si,No" }}</td>
                                      {% else %}
                                      <td>{{ item.is_staff|yesno:"Si,No" }}</td>
                                      {% endif %}                                                                                                           
                                      
                                      <td>
                                                                                                                         
                                        <a href="{% url 'app_perfiles:user_modify' item.id %}">
                                          <button class="btn btn-primary bg-warning btn-outline-light btn-sm" >
                                            <i class="fa fa-edit"></i>
                                          </button>
                                        </a>
                                                                                                                          
                                        <a href="{% url 'perfiles:user_del' item.id %}">
                                          <button class="btn btn-primary bg-danger btn-outline-light btn-sm">
                                            <i class="fa fa-trash-alt"></i>
                                          </button>
                                        </a>
                                        
                                      </td>                                                                      
                                  </tr>
                                  {% endfor %}                              
                              
                              </tbody>                            
                            </table>
                            <!-- /.table -->
                            {% endif %}
                        </div>
                        <!-- /.card-body -->
                      </div>
                      <!-- /.card -->
                    </div>
                    <!-- /.col -->
                </div>
            </div>
        </div>
    </section>
{% endblock content %}

  

    
    